﻿(function (app) {
    var vseTutorialsTrackId = "InteractiveTutorials";

    app.analyticsBridge = {
        trackTutorialOpen: function (tutorialTitle, tutorialType) {
            this._trackFeatureUsage(vseTutorialsTrackId, "OpenTutorial", tutorialTitle, tutorialType);
        },
        trackTutorialStart: function (tutorialTitle, tutorialType) {
            this._trackFeatureUsage(vseTutorialsTrackId, "StartTutorial", tutorialTitle, tutorialType);
        },
        trackTutorialLessonStepComplete: function (tutorialTitle, tutorialType, lessonNumber, lessonTitle, stepNumber, stepTitle) {
            this._trackFeatureUsage(vseTutorialsTrackId, "CompleteTutorialLessonStep", tutorialTitle, tutorialType, lessonTitle, lessonNumber, stepTitle, stepNumber);
        },
        trackTutorialLessonComplete: function (tutorialTitle, tutorialType, lessonNumber, lessonTitle) {
            this._trackFeatureUsage(vseTutorialsTrackId, "CompleteTutorialLesson", tutorialTitle, tutorialType, lessonTitle, lessonNumber);
        },
        trackTutorialComplete: function (tutorialTitle, tutorialType) {
            this._trackFeatureUsage(vseTutorialsTrackId, "CompleteTutorial", tutorialTitle, tutorialType);
        },
        trackTutorialContinue: function (tutorialTitle, tutorialType, lessonNumber, lessonTitle, stepNumber, stepTitle) {
            this._trackFeatureUsage(vseTutorialsTrackId, "ContinueTutorial", tutorialTitle, tutorialType, lessonTitle, lessonNumber, stepTitle, stepNumber);
        },
        trackTutorialRestart: function (tutorialTitle, tutorialType, lessonNumber, lessonTitle, stepNumber, stepTitle) {
            this._trackFeatureUsage(vseTutorialsTrackId, "RestartTutorial", tutorialTitle, tutorialType, lessonTitle, lessonNumber, stepTitle, stepNumber);
        },
        trackTutorialCompleteRating: function (tutorialTitle, tutorialType, rating) {
            this._trackFeatureUsage(vseTutorialsTrackId, "TutorialRating", tutorialTitle, tutorialType, rating);
        },

        _trackFeatureUsage: function () {
            var args = Array.prototype.slice.call(arguments),
                featureName = args.join(".").replace(/\s/g, "_");

            app.bridgeHelper.execute("ICE_AnalyticsBridge", function (analyticsBridge) {
                analyticsBridge.TrackFeatureUsage(featureName);
                console.log("ICE_AnalyticsBridge.TrackFeatureUsage: " + featureName);
            });
        }
    };
})(window.app = window.app || {});