﻿(function (app) {
    var bridgeName = "ICE_OverlaysBridge",
        openOverlays = {};

    app.overlaysBridge = {
        show: function (overlayId, tutorialIndex, lessonIndex) {
            var overlayResponseRequestId = getOverlayResponseRequestId(overlayId, tutorialIndex, lessonIndex),
                deferred = $.Deferred();

            if (openOverlays[overlayResponseRequestId]) {
                throw { message: "overlaysBridge - another request found for id: " + overlayResponseRequestId };
            }

            openOverlays[getOverlayResponseRequestId(overlayId, tutorialIndex, lessonIndex)] = deferred;

            app.bridgeHelper.execute(bridgeName, function (overlaysBridge) {
                overlaysBridge.Show(overlayId, tutorialIndex, lessonIndex);
            });

            return deferred;
        },
        sendResponse: function (overlayId, tutorialIndex, lessonIndex, response) {
            var overlayResponseRequestId = getOverlayResponseRequestId(overlayId, tutorialIndex, lessonIndex);

            app.bridgeHelper.execute(bridgeName, function (overlaysBridge) {
                overlaysBridge.SendResponse(overlayId, tutorialIndex, lessonIndex, response);
            });

            console.log("overlaysBridge - send response: " + overlayResponseRequestId + " = " + response);
        },
        setResponse: function (overlayId, tutorialIndex, lessonIndex, response) {
            var overlayResponseRequestId = getOverlayResponseRequestId(overlayId, tutorialIndex, lessonIndex),
                deferred = openOverlays[overlayResponseRequestId];

            if (deferred) {
                deferred.resolve(response);

                delete openOverlays[overlayResponseRequestId];

                console.log("overlaysBridge - response request: " + overlayResponseRequestId + " = " + response);
            }
            else {
                console.error("overlaysBridge - no response request found for id: " + overlayResponseRequestId);
            }
        }
    };

    function getOverlayResponseRequestId(overlayId, tutorialIndex, lessonIndex) {
        return [overlayId, tutorialIndex, lessonIndex].join("_");
    }
})(window.app = window.app || {});