﻿(function (app) {
    var bridgeName = "ICE_ProgressDataBridge";

    app.progressDataBridge = {
        get: function () {
            var args = null, failResult = {},
                deferred = $.Deferred();

            app.bridgeHelper.cefQuery(bridgeName, "GetProgressData", args, failResult)
                .done(function (response) {
                    deferred.resolve(JSON.parse(response));
                });

            return deferred;
        },
        setCompletedStep: function (tutorialIndex, lessonIndex, stepIndex) {
            this._execute(function (progressDataBridge) {
                progressDataBridge.SetCompletedStep(getTutorialKey(tutorialIndex), lessonIndex, stepIndex);
                console.log("progressData set completed step: " + tutorialIndex + "_" + lessonIndex + "_" + stepIndex);
            });
        },
        addTutorialData: function (tutorialIndex) {
            this._execute(function (progressDataBridge) {
                progressDataBridge.AddTutorialData(getTutorialKey(tutorialIndex));
                console.log("progressData remove tutorial: " + tutorialIndex);
            });
        },
        removeTutorialData: function (tutorialIndex) {
            this._execute(function (progressDataBridge) {
                progressDataBridge.RemoveTutorialData(getTutorialKey(tutorialIndex));
                console.log("progressData remove tutorial: " + tutorialIndex);
            });
        },
        _execute: function (action) {
            app.bridgeHelper.execute(bridgeName, action);
        }
    };

    function getTutorialKey(tutorialIndex) {
        return app.models.tutorials.items[tutorialIndex].metadata.fileName;
    }
})(window.app = window.app || {});