﻿(function (app) {
    var bridgeName = "ICE_ProjectHelperBridge";

    app.projectHelperBridge = {
        openProject: function (projectName) {
            var args = { projectName: projectName },
                failResult = false,
                showLoading = true;

            return app.bridgeHelper.cefQuery(bridgeName, "OpenProject", args, failResult, showLoading);
        },
        createProject: function (projectMetadata) {
            var args = projectMetadata,
                failResult = false,
                showLoading = true;

            return app.bridgeHelper.cefQuery(bridgeName, "CreateProject", args, failResult, showLoading);
        },
        checkIfProjectExists: function (projectName) {
            var args = { projectName: projectName },
                failResult = false;

            return app.bridgeHelper.cefQuery(bridgeName, "CheckIfProjectExists", args, failResult);
        },
        isSimulatorOpenForProject: function (projectName) {
            var args = { projectName: projectName },
                failResult = false;

            return app.bridgeHelper.cefQuery(bridgeName, "IsSimulatorOpenForProject", args, failResult);
        },
        closeSimulator: function (projectName) {
            var args = { projectName: projectName };
            return app.bridgeHelper.cefQuery(bridgeName, "CloseSimulatorProcess", args);
        },
        getSolutionPath: function (projectName) {
            var args = { projectName: projectName },
                failResult = "";

            return app.bridgeHelper.cefQuery(bridgeName, "GetSolutionPath", args, failResult);
        }
    };
})(window.app = window.app || {});