﻿(function (app) {
    var urlPartSeparator = app.constants.urlPartSeparator;

    app.layout = {
        getModel: function () {
            return kendo.observable({
                header: "",
                progress: "",
                isNavVisible: false,
                onNavBackClick: onNavBackClick
            });
        },
        setModelVars: function (model, title, progress, progressBackgroundImage) {
            model.set("header", title);
            model.set("isCompleted", progress === 100);
            model.set("progress", progress);
            model.set("backgroundImage", progressBackgroundImage);
            model.set("isNavVisible", app.router.level > 0);
        }
    };

    function onNavBackClick(e) {
        var route = window.location.hash.substring(1),
            routeParts;

        e.stopPropagation();

        switch (app.router.level) {
            case 0:
                break;
            case 1:
                app.router.navigate(app.routes.root);
                break;
            case 3:
                routeParts = route.split(urlPartSeparator);
                routeParts.splice(-2, 2); // go up 2 levels
                app.router.navigate(routeParts.join(urlPartSeparator));
                break;
        }
    }
})(window.app = window.app || {});