﻿(function (app) {
    app.lessons = {
        initialize: function (tutorial) {
            tutorial.lessons = tutorial.metadata.lessons
                .map(function (item, index) {
                    return {
                        metadata: item,
                        tutorial: function () {
                            return this.parent().parent();
                        },
                        isCurrent: function () {
                            return item.index === this.tutorial().get("currentOpenLessonIndex") - 0;
                        },
                        progress: function () {
                            var completedStepsCount = 0;

                            this.steps.every(function (stepItem) {
                                var isCompleted = stepItem.get("isCompleted");
                                if (isCompleted) {
                                    completedStepsCount++;
                                }

                                return isCompleted;
                            });

                            return Math.round(completedStepsCount * 100 / this.steps.length);
                        },
                        onLessonHeadingClick: function (e) {
                            e.stopPropagation();

                            if (this.metadata.index !== this.tutorial().get("currentOpenLessonIndex")) {
                                this.tutorial().set("currentOpenLessonIndex", this.metadata.index);
                            }
                            else {
                                this.tutorial().set("currentOpenLessonIndex", -1);
                            }

                            this.tutorial().lessons.forEach(function (lesson) {
                                lesson.trigger("change", { field: "isCurrent" });
                            });

                            console.log("lesson opened: " + this.metadata.index);
                        }
                    };
                });

            delete tutorial.metadata.lessons;
        }
    };
})(window.app = window.app || {})